#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <errno.h>

#include "modules.h"

int log_temp(void) {
    FILE *fp_log;
    FILE *fp_temp;
    char cpu_temp[BUF_MAX];
    char soc_temp[BUF_MAX];
    char now[BUF_MAX];
    char log[BUF_MAX];
    int is_thermal1 = 0;
    time_t unix_time = time(NULL);
    struct tm *local;
    struct stat st;
    char *log_path = "/vol_data/log";
    char *thermal_zone0_path = "/sys/class/thermal/thermal_zone0/temp";
    char *thermal_zone1_path = "/sys/class/thermal/thermal_zone1/temp";

    if (stat(log_path, &st) != 0) {
        if (mkdir(log_path, 0755) != 0) {
            fprintf(stderr, "mkdir failed error: %m:\n");
            return 1;
        }
    }

    if ((fp_log = fopen("/vol_data/log/temp.txt", "w")) == NULL) {
        fprintf(stderr, "fopen failed error: %m: /vol_data/log/temp.txt\n");
        return 1;
    }

    if (stat(thermal_zone1_path, &st) == 0) {
        if (fputs("time, cpu temperature, soc temperature\n", fp_log) == EOF) {
            fprintf(stderr, "fputs failed error: %m\n");
            return 1;
        }
        is_thermal1 = 1;
    } else {
        if (fputs("time, cpu temperature\n", fp_log) == EOF) {
            fprintf(stderr, "fputs failed error: %m\n");
            return 1;
        }
    }

    local = localtime(&unix_time);
    strftime(now, sizeof(now),"%Y-%m-%d %H:%M:%S", local);
    fprintf(fp_log, "%s", now);

    if ((fp_temp = fopen(thermal_zone0_path, "r")) == NULL) {
        fprintf(stderr, "fopen failed error: %m: %s\n", thermal_zone0_path);
        return 1;
    }

    if (!fgets(cpu_temp, BUF_MAX, fp_temp)) {
        fprintf(stderr, "fgets failed error: cpu_temp: %m\n");
        return 1;
    }

    if (fclose(fp_temp) != 0) {
        fprintf(stderr, "fclose failed error: cpu_temp: %m\n");
        return 1;
    }

    cpu_temp[strlen(cpu_temp) - 4] = '\0';
    fprintf(fp_log, ", %s", cpu_temp);

    if (is_thermal1) {
        if ((fp_temp = fopen(thermal_zone1_path, "r")) == NULL) {
            fprintf(stderr, "fopen failed error: %m: %s\n", thermal_zone1_path);
            return 1;
        }

        if (!fgets(soc_temp, BUF_MAX, fp_temp)) {
            fprintf(stderr, "fgets failed error: soc_temp: %m\n");
            return 1;
        }
        if (fclose(fp_temp) != 0) {
            fprintf(stderr, "fclose failed error: soc_temp: %m\n");
            return 1;
        }

        soc_temp[strlen(soc_temp) - 4] = '\0';
        fprintf(fp_log, ", %s", soc_temp);
    }

    fprintf(fp_log, "\n");

    if(fputs(log, fp_log) == EOF) {
        fprintf(stderr, "fputs failed error: %m\n");
        return 1;
    }

    if(fclose(fp_log) != 0) {
        fprintf(stderr, "fclose failed error: /vol_data/log/temp.txt: %m\n");
        return 1;
    }

    return 0;
}
